summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorPatrick McLean <patrick.mclean@sony.com>2019-12-11 14:40:19 -0800
committerPatrick McLean <chutzpah@gentoo.org>2019-12-11 14:40:34 -0800
commit0987c229b79bbbde9a1d36f619be9cd48be92987 (patch)
treea93ddfce85236061c8ae431989aaf0a5b87f5271
parentdev-python/prettytable-0.7.2-r1: Add python3_8 (diff)
downloadgentoo-0987c229b79bbbde9a1d36f619be9cd48be92987.tar.gz
gentoo-0987c229b79bbbde9a1d36f619be9cd48be92987.tar.bz2
gentoo-0987c229b79bbbde9a1d36f619be9cd48be92987.zip
sys-cluster/ceph: Version bump to 14.2.5
Copyright: Sony Interactive Entertainment Inc. Package-Manager: Portage-2.3.81, Repoman-2.3.20 Signed-off-by: Patrick McLean <chutzpah@gentoo.org>
-rw-r--r--sys-cluster/ceph/Manifest1
-rw-r--r--sys-cluster/ceph/ceph-14.2.5.ebuild370
-rw-r--r--sys-cluster/ceph/files/ceph-14.2.5-boost-1.6-python-sonames.patch26
-rw-r--r--sys-cluster/ceph/files/ceph-14.2.5-boost-1.70.patch78
-rw-r--r--sys-cluster/ceph/files/ceph-14.2.5-boost-sonames.patch471
-rw-r--r--sys-cluster/ceph/files/ceph-14.2.5-no-virtualenvs.patch39
-rw-r--r--sys-cluster/ceph/metadata.xml1
7 files changed, 986 insertions, 0 deletions
diff --git a/sys-cluster/ceph/Manifest b/sys-cluster/ceph/Manifest
index b84a125b65ac..e46535296330 100644
--- a/sys-cluster/ceph/Manifest
+++ b/sys-cluster/ceph/Manifest
@@ -4,3 +4,4 @@ DIST ceph-12.2.8.tar.gz 77243685 BLAKE2B 37c34396a0c276b8d79735e14934ac70da02482
DIST ceph-13.2.5.tar.gz 91006057 BLAKE2B 68551e2f54d78aff7b0e9ec3c62e6a3394dd7c23e80924a5b400cd9666a05a42e5f22445deee4040f1b78201c6a6660b283109878d4c92d845821bff831c8a5e SHA512 6daea524523f829e725609328ea71f416b2c3a9530fa8956720a7bc69dc08e55a169654f500704579dc9ba693f04eedd7e04614c0850e9ab1169cd45f19039f8
DIST ceph-13.2.6.tar.gz 90808224 BLAKE2B cd7b4f4838eafc9dd580102cbb5247b86a153f90127f81355b556f32dbbacd2d7fb0144d15f99869a318a7148d2f50a9f995eb05aee056d7a5843830ede5702c SHA512 1e9c08d16b14447bf6b8bb72144e053aa9d5cf390bb4a6e878869e38895d3698073502fe9c4f8b775a3da872b920444bd01260105d3a839e53cf90cd27c6ab9c
DIST ceph-14.2.4.tar.gz 116371380 BLAKE2B 2d2c78ec32a0749df16e9c527d2fd087a75daeb2ef26ac5f6aa641989eab62fa276eb320b873740e9eee3fd4f369da152c53c2389b1def1b6a45906ccc1bd1f1 SHA512 dc60321ed4dcaccacca711ab70c35011b5dfc6b8369016fb413a9976199ed4ba22c7dc87ba1ebaf1118513dee1a0c263c99ab137f27fc03c55e8a0625a3bdcc0
+DIST ceph-14.2.5.tar.gz 118629512 BLAKE2B d1e1e1a2981ab733a8233b6de504c626f9ee776f6a980de61c95b16c85d48f674c40b2013327ce4efb35a844b22a169f55500d45ae827d6fb42e9a5cbae87aea SHA512 38da62a38960d3618e2689f0e882785d4d95358b4a3b3b5b83e54e227cff9e69f4cca0b63d2d55d69e3916055818e6cf9067f2c2eddeb221ef4bc64a13cfa22b
diff --git a/sys-cluster/ceph/ceph-14.2.5.ebuild b/sys-cluster/ceph/ceph-14.2.5.ebuild
new file mode 100644
index 000000000000..95bdb0d89fbc
--- /dev/null
+++ b/sys-cluster/ceph/ceph-14.2.5.ebuild
@@ -0,0 +1,370 @@
+# Copyright 1999-2019 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+PYTHON_COMPAT=( python{2_7,3_{5,6,7}} )
+CMAKE_MAKEFILE_GENERATOR=emake
+
+DISTUTILS_OPTIONAL=1
+
+inherit check-reqs bash-completion-r1 cmake-utils distutils-r1 flag-o-matic \
+ multiprocessing python-r1 udev readme.gentoo-r1 toolchain-funcs \
+ systemd
+
+if [[ ${PV} == *9999* ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/ceph/ceph.git"
+ SRC_URI=""
+else
+ SRC_URI="https://download.ceph.com/tarballs/${P}.tar.gz"
+ KEYWORDS="~amd64 ~arm64"
+fi
+
+DESCRIPTION="Ceph distributed filesystem"
+HOMEPAGE="https://ceph.com/"
+
+LICENSE="LGPL-2.1 CC-BY-SA-3.0 GPL-2 GPL-2+ LGPL-2+ BSD Boost-1.0 MIT public-domain"
+SLOT="0"
+
+CPU_FLAGS_X86=(sse{,2,3,4_1,4_2} ssse3)
+
+IUSE="babeltrace cephfs dpdk fuse grafana jemalloc kerberos ldap libressl"
+IUSE+=" lttng +mgr numa rabbitmq +radosgw +ssl spdk static-libs system-boost"
+IUSE+=" systemd +tcmalloc test xfs zfs"
+IUSE+=" $(printf "cpu_flags_x86_%s\n" ${CPU_FLAGS_X86[@]})"
+
+COMMON_DEPEND="
+ acct-group/ceph
+ acct-user/ceph
+ virtual/libudev:=
+ app-arch/bzip2:=[static-libs?]
+ app-arch/lz4:=[static-libs?]
+ app-arch/snappy:=[static-libs?]
+ app-arch/zstd:=[static-libs?]
+ app-shells/bash:0
+ app-misc/jq:=[static-libs?]
+ dev-libs/crypto++:=[static-libs?]
+ dev-libs/leveldb:=[snappy,static-libs?,tcmalloc(-)?]
+ dev-libs/libaio:=[static-libs?]
+ dev-libs/libnl:3=[static-libs?]
+ dev-libs/libxml2:=[static-libs?]
+ dev-libs/nss:=
+ sys-auth/oath-toolkit:=
+ sys-apps/coreutils
+ sys-apps/grep
+ sys-apps/keyutils:=[static-libs?]
+ sys-apps/util-linux:=[static-libs?]
+ sys-apps/sed
+ sys-apps/util-linux
+ sys-libs/libcap-ng:=[static-libs?]
+ sys-libs/ncurses:0=[static-libs?]
+ sys-libs/zlib:=[static-libs?]
+ babeltrace? ( dev-util/babeltrace )
+ ldap? ( net-nds/openldap:=[static-libs?] )
+ lttng? ( dev-util/lttng-ust:= )
+ fuse? ( sys-fs/fuse:0=[static-libs?] )
+ kerberos? ( virtual/krb5 )
+ rabbitmq? ( net-libs/rabbitmq-c:=[static-libs?] )
+ ssl? (
+ !libressl? ( dev-libs/openssl:=[static-libs?] )
+ libressl? ( dev-libs/libressl:=[static-libs?] )
+ )
+ xfs? ( sys-fs/xfsprogs:=[static-libs(+)?] )
+ zfs? ( sys-fs/zfs:=[static-libs?] )
+ radosgw? (
+ dev-libs/expat:=[static-libs?]
+ !libressl? (
+ dev-libs/openssl:=[static-libs?]
+ net-misc/curl:=[curl_ssl_openssl,static-libs?]
+ )
+ libressl? (
+ dev-libs/libressl:=[static-libs?]
+ net-misc/curl:=[curl_ssl_libressl,static-libs?]
+ )
+ )
+ system-boost? (
+ || (
+ =dev-libs/boost-1.71*[threads,context,python,static-libs?,${PYTHON_USEDEP}]
+ =dev-libs/boost-1.70*[threads,context,python,static-libs?,${PYTHON_USEDEP}]
+ =dev-libs/boost-1.67*[threads,context,python,static-libs?,${PYTHON_USEDEP}]
+ )
+ dev-libs/boost:=[threads,context,python,static-libs?,${PYTHON_USEDEP}]
+ )
+ jemalloc? ( dev-libs/jemalloc:=[static-libs?] )
+ !jemalloc? ( >=dev-util/google-perftools-2.4:=[static-libs?] )
+ ${PYTHON_DEPS}
+"
+DEPEND="${COMMON_DEPEND}
+ amd64? ( dev-lang/yasm )
+ x86? ( dev-lang/yasm )
+ dev-python/cython[${PYTHON_USEDEP}]
+ dev-python/sphinx
+ dev-util/cunit
+ test? (
+ dev-python/coverage[${PYTHON_USEDEP}]
+ dev-python/virtualenv[${PYTHON_USEDEP}]
+ sys-apps/grep[pcre]
+ sys-fs/btrfs-progs
+ )
+"
+BDEPEND="
+ app-arch/cpio
+ >=dev-util/cmake-3.5.0
+ dev-util/gperf
+ dev-util/valgrind
+ sys-apps/coreutils
+ sys-apps/findutils
+ sys-apps/grep
+ sys-apps/sed
+ sys-apps/which
+ sys-devel/bc
+ sys-devel/patch
+ virtual/pkgconfig
+"
+RDEPEND="${COMMON_DEPEND}
+ net-misc/socat
+ sys-apps/gptfdisk
+ sys-block/parted
+ sys-fs/cryptsetup
+ sys-fs/lvm2[-device-mapper-only(-)]
+ sys-fs/lsscsi
+ virtual/awk
+ dev-python/bcrypt[${PYTHON_USEDEP}]
+ dev-python/cherrypy[${PYTHON_USEDEP}]
+ dev-python/flask[${PYTHON_USEDEP}]
+ dev-python/jinja[${PYTHON_USEDEP}]
+ dev-python/pecan[${PYTHON_USEDEP}]
+ dev-python/prettytable[${PYTHON_USEDEP}]
+ dev-python/pyopenssl[${PYTHON_USEDEP}]
+ dev-python/requests[${PYTHON_USEDEP}]
+ dev-python/werkzeug[${PYTHON_USEDEP}]
+"
+REQUIRED_USE="
+ ${PYTHON_REQUIRED_USE}
+ || ( $(python_gen_useflags 'python3*') )
+ ?? ( jemalloc tcmalloc )
+ rabbitmq? ( radosgw )
+"
+
+# the tests need root access
+RESTRICT="test? ( userpriv )"
+
+# distribution tarball does not include everything needed for tests
+RESTRICT+=" test"
+
+# false positives unless all USE flags are on
+CMAKE_WARN_UNUSED_CLI="no"
+
+PATCHES=(
+ "${FILESDIR}/ceph-12.2.0-use-provided-cpu-flag-values.patch"
+ "${FILESDIR}/ceph-14.2.0-cflags.patch"
+ "${FILESDIR}/ceph-12.2.4-boost-build-none-options.patch"
+ "${FILESDIR}/ceph-13.2.0-cflags.patch"
+ "${FILESDIR}/ceph-14.2.0-mgr-python-version.patch"
+ "${FILESDIR}/ceph-14.2.5-no-virtualenvs.patch"
+ "${FILESDIR}/ceph-13.2.2-dont-install-sysvinit-script.patch"
+ "${FILESDIR}/ceph-14.2.0-dpdk-cflags.patch"
+ "${FILESDIR}/ceph-14.2.0-link-crc32-statically.patch"
+ "${FILESDIR}/ceph-14.2.0-cython-0.29.patch"
+ "${FILESDIR}/ceph-14.2.5-boost-1.70.patch"
+ "${FILESDIR}/ceph-14.2.3-dpdk-compile-fix-1.patch"
+ "${FILESDIR}/ceph-14.2.4-python-executable.patch"
+ "${FILESDIR}/ceph-14.2.4-undefined-behaviour.patch"
+)
+
+check-reqs_export_vars() {
+ if use amd64; then
+ CHECKREQS_DISK_BUILD="12G"
+ CHECKREQS_DISK_USR="460M"
+ else
+ CHECKREQS_DISK_BUILD="1400M"
+ CHECKREQS_DISK_USR="450M"
+ fi
+
+ export CHECKREQS_DISK_BUILD CHECKREQS_DISK_USR
+}
+
+pkg_pretend() {
+ check-reqs_export_vars
+ check-reqs_pkg_pretend
+}
+
+pkg_setup() {
+ python_setup 'python3*'
+ check-reqs_export_vars
+ check-reqs_pkg_setup
+}
+
+src_prepare() {
+ cmake-utils_src_prepare
+
+ if use system-boost; then
+ eapply "${FILESDIR}/ceph-14.2.5-boost-sonames.patch"
+
+ find "${S}" -name '*.cmake' -or -name 'CMakeLists.txt' -print0 \
+ | xargs --null sed -e 's|Boost::|Boost_|g' -i || die
+
+ has_version '>=dev-libs/boost-1.70.0' || \
+ eapply "${FILESDIR}/ceph-14.2.5-boost-1.6-python-sonames.patch"
+ fi
+
+ sed -i -r "s:DESTINATION .+\\):DESTINATION $(get_bashcompdir)\\):" \
+ src/bash_completion/CMakeLists.txt || die
+
+ # remove tests that need root access
+ rm src/test/cli/ceph-authtool/cap*.t || die
+}
+
+ceph_src_configure() {
+ local flag
+ local mycmakeargs=(
+ -DWITH_BABELTRACE=$(usex babeltrace)
+ -DWITH_CEPHFS=$(usex cephfs)
+ -DWITH_CEPHFS_SHELL=$(if python_is_python3; then usex cephfs; else echo OFF; fi)
+ -DWITH_DPDK=$(usex dpdk)
+ -DWITH_DPDK=$(usex spdk)
+ -DWITH_FUSE=$(usex fuse)
+ -DWITH_LTTNG=$(usex lttng)
+ -DWITH_GSSAPI=$(usex kerberos)
+ -DWITH_GRAFANA=$(usex grafana)
+ -DWITH_MGR=$(usex mgr)
+ -DWITH_MGR_DASHBOARD_FRONTEND=NO
+ -DWITH_NUMA=$(usex numa)
+ -DWITH_OPENLDAP=$(usex ldap)
+ -DMGR_PYTHON_VERSION=$(if python_is_python3; then echo 3; else echo 2; fi)
+ -DWITH_PYTHON3=$(if python_is_python3; then echo "ON"; else echo "OFF"; fi)
+ -DWITH_PYTHON2=$(if python_is_python3; then echo "OFF"; else echo "ON"; fi)
+ -DWITH_RADOSGW=$(usex radosgw)
+ -DWITH_RADOSGW_AMQP_ENDPOINT=$(usex rabbitmq)
+ -DWITH_SSL=$(usex ssl)
+ -DWITH_SYSTEMD=$(usex systemd)
+ -DWITH_TESTS=$(usex test)
+ -DWITH_XFS=$(usex xfs)
+ -DWITH_ZFS=$(usex zfs)
+ -DENABLE_SHARED=$(usex static-libs '' 'ON' 'OFF')
+ -DALLOCATOR=$(usex tcmalloc 'tcmalloc' "$(usex jemalloc 'jemalloc' 'libc')")
+ -DWITH_SYSTEM_BOOST=$(usex system-boost)
+ -DBOOST_J=$(makeopts_jobs)
+ -DWITH_RDMA=no
+ -DWITH_TBB=no
+ -DSYSTEMD_UNITDIR=$(systemd_get_systemunitdir)
+ -DEPYTHON_VERSION="${EPYTHON#python}"
+ -DCMAKE_INSTALL_DOCDIR="${EPREFIX}/usr/share/doc/${PN}-${PVR}"
+ -DCMAKE_INSTALL_SYSCONFDIR="${EPREFIX}/etc"
+ #-Wno-dev
+ )
+ if use amd64 || use x86; then
+ for flag in ${CPU_FLAGS_X86[@]}; do
+ mycmakeargs+=("$(usex cpu_flags_x86_${flag} "-DHAVE_INTEL_${flag^^}=1")")
+ done
+ fi
+
+ rm -f "${BUILD_DIR:-${S}}/CMakeCache.txt" \
+ || die "failed to remove cmake cache"
+
+ cmake-utils_src_configure
+
+ # bug #630232
+ sed -i "s:\"${T//:\\:}/${EPYTHON}/bin/python\":\"${PYTHON}\":" \
+ "${BUILD_DIR:-${S}}"/include/acconfig.h \
+ || die "sed failed"
+}
+
+src_configure() {
+ ceph_src_configure
+}
+
+python_compile() {
+ local CMAKE_USE_DIR="${S}"
+ ceph_src_configure
+
+ pushd "${BUILD_DIR}/src/pybind" >/dev/null || die
+ emake VERBOSE=1 clean
+ emake VERBOSE=1 all
+
+ # python modules are only compiled with "make install" so we need to do this to
+ # prevent doing a bunch of compilation in src_install
+ DESTDIR="${T}" emake VERBOSE=1 install
+ popd >/dev/null || die
+}
+
+src_compile() {
+ cmake-utils_src_make VERBOSE=1 all
+
+ # we have to do this here to prevent from building everything multiple times
+ python_copy_sources
+ python_foreach_impl python_compile
+}
+
+src_test() {
+ make check || die "make check failed"
+}
+
+python_install() {
+ local CMAKE_USE_DIR="${S}"
+ pushd "${BUILD_DIR}/src/pybind" >/dev/null || die
+ DESTDIR="${ED}" emake VERBOSE=1 install
+ popd >/dev/null || die
+
+ python_optimize
+}
+
+src_install() {
+ cmake-utils_src_install
+ python_foreach_impl python_install
+
+ find "${ED}" -name '*.la' -type f -delete || die
+
+ exeinto /usr/$(get_libdir)/ceph
+ newexe "${BUILD_DIR}/bin/init-ceph" init-ceph
+
+ insinto /etc/logrotate.d/
+ newins "${FILESDIR}"/ceph.logrotate-r2 ${PN}
+
+ keepdir /var/lib/${PN}{,/tmp} /var/log/${PN}/stat
+
+ fowners -R ceph:ceph /var/log/ceph
+
+ newinitd "${FILESDIR}/rbdmap.initd" rbdmap
+ newinitd "${FILESDIR}/${PN}.initd-r12" ${PN}
+ newconfd "${FILESDIR}/${PN}.confd-r5" ${PN}
+
+ insinto /etc/sysctl.d
+ newins "${FILESDIR}"/sysctld 90-${PN}.conf
+
+ use tcmalloc && newenvd "${FILESDIR}"/envd-tcmalloc 99${PN}-tcmalloc
+
+ # units aren't installed by the build system unless systemd is enabled
+ # so no point installing these with the USE flag disabled
+ if use systemd; then
+ systemd_install_serviced "${FILESDIR}/ceph-mds_at.service.conf" \
+ "ceph-mds@.service"
+
+ systemd_install_serviced "${FILESDIR}/ceph-osd_at.service.conf" \
+ "ceph-osd@.service"
+ fi
+
+ udev_dorules udev/*.rules
+
+ readme.gentoo_create_doc
+
+ python_setup 'python3*'
+
+ # bug #630232
+ sed -i -r "s:${T//:/\\:}/${EPYTHON}:/usr:" "${ED}"/usr/bin/ceph{,-crash} \
+ || die "sed failed"
+
+ python_fix_shebang "${ED}"/usr/{,s}bin/
+
+ # python_fix_shebang apparently is not idempotent
+ local shebang_regex='(/usr/lib/python-exec/python[0-9]\.[0-9]/python)[0-9]\.[0-9]'
+ grep -r -E -l --null "${shebang_regex}" "${ED}"/usr/{s,}bin/ \
+ | xargs --null --no-run-if-empty -- sed -i -r "s:${shebang_regex}:\1:" || die
+
+ local -a rados_classes=( "${ED}/usr/$(get_libdir)/rados-classes"/* )
+ dostrip -x "${rados_classes[@]#${ED}}"
+}
+
+pkg_postinst() {
+ readme.gentoo_print_elog
+}
diff --git a/sys-cluster/ceph/files/ceph-14.2.5-boost-1.6-python-sonames.patch b/sys-cluster/ceph/files/ceph-14.2.5-boost-1.6-python-sonames.patch
new file mode 100644
index 000000000000..318844f6c025
--- /dev/null
+++ b/sys-cluster/ceph/files/ceph-14.2.5-boost-1.6-python-sonames.patch
@@ -0,0 +1,26 @@
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 1e9ebfbb41..1a858a6e3f 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -649,7 +649,7 @@ set(BOOST_HEADER_COMPONENTS container)
+
+ if(WITH_MGR)
+ list(APPEND BOOST_COMPONENTS
+- python${MGR_PYTHON_VERSION_MAJOR}${MGR_PYTHON_VERSION_MINOR})
++ python-${MGR_PYTHON_VERSION_MAJOR}.${MGR_PYTHON_VERSION_MINOR})
+ endif()
+ if(WITH_BOOST_CONTEXT)
+ list(APPEND BOOST_COMPONENTS context coroutine)
+diff --git a/cmake/modules/BuildBoost.cmake b/cmake/modules/BuildBoost.cmake
+index f46cc0d485..3cc6340b2c 100644
+--- a/cmake/modules/BuildBoost.cmake
++++ b/cmake/modules/BuildBoost.cmake
+@@ -205,7 +205,7 @@ macro(build_boost version)
+ endif()
+ add_dependencies(Boost::${c} Boost)
+ if(c MATCHES "^python")
+- set(c "python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR}")
++ set(c "python-${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
+ endif()
+ if(Boost_USE_STATIC_LIBS)
+ set(Boost_${upper_c}_LIBRARY
diff --git a/sys-cluster/ceph/files/ceph-14.2.5-boost-1.70.patch b/sys-cluster/ceph/files/ceph-14.2.5-boost-1.70.patch
new file mode 100644
index 000000000000..693925e8825c
--- /dev/null
+++ b/sys-cluster/ceph/files/ceph-14.2.5-boost-1.70.patch
@@ -0,0 +1,78 @@
+diff --git a/src/rgw/rgw_asio_frontend.cc b/src/rgw/rgw_asio_frontend.cc
+index 82e2a45da6..8750c5648f 100644
+--- a/src/rgw/rgw_asio_frontend.cc
++++ b/src/rgw/rgw_asio_frontend.cc
+@@ -83,7 +83,8 @@ class StreamIO : public rgw::asio::ClientIO {
+ using SharedMutex = ceph::async::SharedMutex<boost::asio::io_context::executor_type>;
+
+ template <typename Stream>
+-void handle_connection(RGWProcessEnv& env, Stream& stream,
++void handle_connection(boost::asio::io_context& context,
++ RGWProcessEnv& env, Stream& stream,
+ parse_buffer& buffer, bool is_ssl,
+ SharedMutex& pause_mutex,
+ rgw::dmclock::Scheduler *scheduler,
+@@ -160,7 +161,7 @@ void handle_connection(RGWProcessEnv& env, Stream& stream,
+ rgw::io::add_conlen_controlling(
+ &real_client))));
+ RGWRestfulIO client(cct, &real_client_io);
+- auto y = optional_yield{socket.get_io_context(), yield};
++ auto y = optional_yield{context, yield};
+ process_request(env.store, env.rest, &req, env.uri_prefix,
+ *env.auth_registry, &client, env.olog, y, scheduler);
+ }
+@@ -604,7 +605,7 @@ void AsioFrontend::accept(Listener& l, boost::system::error_code ec)
+ return;
+ }
+ buffer->consume(bytes);
+- handle_connection(env, stream, *buffer, true, pause_mutex,
++ handle_connection(context, env, stream, *buffer, true, pause_mutex,
+ scheduler.get(), ec, yield);
+ if (!ec) {
+ // ssl shutdown (ignoring errors)
+@@ -622,7 +623,7 @@ void AsioFrontend::accept(Listener& l, boost::system::error_code ec)
+ auto c = connections.add(conn);
+ auto buffer = std::make_unique<parse_buffer>();
+ boost::system::error_code ec;
+- handle_connection(env, s, *buffer, false, pause_mutex,
++ handle_connection(context, env, s, *buffer, false, pause_mutex,
+ scheduler.get(), ec, yield);
+ s.shutdown(tcp::socket::shutdown_both, ec);
+ });
+diff --git a/src/rgw/rgw_dmclock_async_scheduler.h b/src/rgw/rgw_dmclock_async_scheduler.h
+index 70487a5253..1d454acd2e 100644
+--- a/src/rgw/rgw_dmclock_async_scheduler.h
++++ b/src/rgw/rgw_dmclock_async_scheduler.h
+@@ -82,7 +82,12 @@ class AsyncScheduler : public md_config_obs_t, public Scheduler {
+ using Completion = async::Completion<Signature, async::AsBase<Request>>;
+
+ using Clock = ceph::coarse_real_clock;
++#if BOOST_VERSION < 107000
+ using Timer = boost::asio::basic_waitable_timer<Clock>;
++#else
++ using Timer = boost::asio::basic_waitable_timer<Clock,
++ boost::asio::wait_traits<Clock>, executor_type>;
++#endif
+ Timer timer; //< timer for the next scheduled request
+
+ CephContext *const cct;
+diff --git a/src/rgw/rgw_reshard.h b/src/rgw/rgw_reshard.h
+index d99a6ff68d..213fc238d2 100644
+--- a/src/rgw/rgw_reshard.h
++++ b/src/rgw/rgw_reshard.h
+@@ -183,7 +183,14 @@ class RGWReshardWait {
+ ceph::condition_variable cond;
+
+ struct Waiter : boost::intrusive::list_base_hook<> {
+- boost::asio::basic_waitable_timer<Clock> timer;
++#if BOOST_VERSION < 107000
++ using Timer = boost::asio::basic_waitable_timer<Clock>;
++#else
++ using Executor = boost::asio::io_context::executor_type;
++ using Timer = boost::asio::basic_waitable_timer<Clock,
++ boost::asio::wait_traits<Clock>, Executor>;
++#endif
++ Timer timer;
+ explicit Waiter(boost::asio::io_context& ioc) : timer(ioc) {}
+ };
+ boost::intrusive::list<Waiter> waiters;
diff --git a/sys-cluster/ceph/files/ceph-14.2.5-boost-sonames.patch b/sys-cluster/ceph/files/ceph-14.2.5-boost-sonames.patch
new file mode 100644
index 000000000000..d8c26bcdfe21
--- /dev/null
+++ b/sys-cluster/ceph/files/ceph-14.2.5-boost-sonames.patch
@@ -0,0 +1,471 @@
+diff --git a/cmake/modules/BuildBoost.cmake b/cmake/modules/BuildBoost.cmake
+index f46cc0d485..39bb081b1b 100644
+--- a/cmake/modules/BuildBoost.cmake
++++ b/cmake/modules/BuildBoost.cmake
+@@ -199,13 +199,13 @@ macro(build_boost version)
+ foreach(c ${Boost_BUILD_COMPONENTS})
+ string(TOUPPER ${c} upper_c)
+ if(Boost_USE_STATIC_LIBS)
+- add_library(Boost::${c} STATIC IMPORTED)
++ add_library(Boost_${c} STATIC IMPORTED)
+ else()
+- add_library(Boost::${c} SHARED IMPORTED)
++ add_library(Boost_${c} SHARED IMPORTED)
+ endif()
+- add_dependencies(Boost::${c} Boost)
++ add_dependencies(Boost_${c} Boost)
+ if(c MATCHES "^python")
+- set(c "python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR}")
++ set(c "python-${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
+ endif()
+ if(Boost_USE_STATIC_LIBS)
+ set(Boost_${upper_c}_LIBRARY
+@@ -215,7 +215,7 @@ macro(build_boost version)
+ ${install_dir}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}boost_${c}${CMAKE_SHARED_LIBRARY_SUFFIX})
+ endif()
+ unset(buildid)
+- set_target_properties(Boost::${c} PROPERTIES
++ set_target_properties(Boost_${c} PROPERTIES
+ INTERFACE_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIRS}"
+ IMPORTED_LINK_INTERFACE_LANGUAGES "CXX"
+ IMPORTED_LOCATION "${Boost_${upper_c}_LIBRARY}")
+@@ -224,19 +224,19 @@ macro(build_boost version)
+ foreach(c ${Boost_BUILD_COMPONENTS})
+ if(Boost_${c}_DEPENDENCIES)
+ foreach(dep ${Boost_${c}_DEPENDENCIES})
+- list(APPEND dependencies Boost::${dep})
++ list(APPEND dependencies Boost_${dep})
+ endforeach()
+- set_target_properties(Boost::${c} PROPERTIES
++ set_target_properties(Boost_${c} PROPERTIES
+ INTERFACE_LINK_LIBRARIES "${dependencies}")
+ unset(dependencies)
+ endif()
+ endforeach()
+
+ # for header-only libraries
+- add_library(Boost::boost INTERFACE IMPORTED)
+- set_target_properties(Boost::boost PROPERTIES
++ add_library(Boost_boost INTERFACE IMPORTED)
++ set_target_properties(Boost_boost PROPERTIES
+ INTERFACE_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIRS}")
+- add_dependencies(Boost::boost Boost)
++ add_dependencies(Boost_boost Boost)
+ find_package_handle_standard_args(Boost DEFAULT_MSG
+ Boost_INCLUDE_DIRS Boost_LIBRARIES)
+ mark_as_advanced(Boost_LIBRARIES BOOST_INCLUDE_DIRS)
+@@ -253,7 +253,7 @@ function(maybe_add_boost_dep target)
+ get_filename_component(ext ${src} EXT)
+ # assuming all cxx source files include boost header(s)
+ if(ext MATCHES ".cc|.cpp|.cxx")
+- add_dependencies(${target} Boost::boost)
++ add_dependencies(${target} Boost_boost)
+ return()
+ endif()
+ endforeach()
+diff --git a/cmake/modules/FindBoost.cmake b/cmake/modules/FindBoost.cmake
+index e2525b8934..e728e5a9d2 100644
+--- a/cmake/modules/FindBoost.cmake
++++ b/cmake/modules/FindBoost.cmake
+@@ -340,10 +340,6 @@ macro(_Boost_ADJUST_LIB_VARS basename)
+
+ if(Boost_${basename}_LIBRARY AND Boost_${basename}_HEADER)
+ set(Boost_${basename}_FOUND ON)
+- if("x${basename}" STREQUAL "xTHREAD" AND NOT TARGET Threads::Threads)
+- string(APPEND Boost_ERROR_REASON_THREAD " (missing dependency: Threads)")
+- set(Boost_THREAD_FOUND OFF)
+- endif()
+ endif()
+
+ endif()
+@@ -919,7 +915,7 @@ function(_Boost_COMPONENT_DEPENDENCIES component _ret)
+ if (NOT _boost_DEPS_STRING)
+ set(_boost_DEPS_STRING "(none)")
+ endif()
+- # message(STATUS "Dependencies for Boost::${component}: ${_boost_DEPS_STRING}")
++ # message(STATUS "Dependencies for Boost_${component}: ${_boost_DEPS_STRING}")
+ endfunction()
+
+ #
+@@ -1003,7 +999,7 @@ function(_Boost_COMPONENT_HEADERS component _hdrs)
+ if (NOT _boost_HDRS_STRING)
+ set(_boost_HDRS_STRING "(none)")
+ endif()
+- # message(STATUS "Headers for Boost::${component}: ${_boost_HDRS_STRING}")
++ # message(STATUS "Headers for Boost_${component}: ${_boost_HDRS_STRING}")
+ endfunction()
+
+ #
+@@ -1051,7 +1047,7 @@ endfunction()
+
+ #
+ # Some boost libraries may require particular set of compler features.
+-# The very first one was `boost::fiber` introduced in Boost 1.62.
++# The very first one was `boost_fiber` introduced in Boost 1.62.
+ # One can check required compiler features of it in
+ # - `${Boost_ROOT}/libs/fiber/build/Jamfile.v2`;
+ # - `${Boost_ROOT}/libs/context/build/Jamfile.v2`.
+@@ -1178,7 +1174,7 @@ else()
+ # _Boost_COMPONENT_HEADERS. See the instructions at the top of
+ # _Boost_COMPONENT_DEPENDENCIES.
+ set(_Boost_KNOWN_VERSIONS ${Boost_ADDITIONAL_VERSIONS}
+- "1.70.0" "1.70" "1.69.0" "1.69"
++ "1.71.0" "1.71" "1.70.0" "1.70" "1.69.0" "1.69"
+ "1.68.0" "1.68" "1.67.0" "1.67" "1.66.0" "1.66" "1.65.1" "1.65.0" "1.65"
+ "1.64.0" "1.64" "1.63.0" "1.63" "1.62.0" "1.62" "1.61.0" "1.61" "1.60.0" "1.60"
+ "1.59.0" "1.59" "1.58.0" "1.58" "1.57.0" "1.57" "1.56.0" "1.56" "1.55.0" "1.55"
+@@ -1235,10 +1231,10 @@ endif()
+ # on all platforms to keep end user code free from platform dependent
+ # code. Also provide convenience targets to disable autolinking and
+ # enable dynamic linking.
+-if(NOT TARGET Boost::diagnostic_definitions)
+- add_library(Boost::diagnostic_definitions INTERFACE IMPORTED)
+- add_library(Boost::disable_autolinking INTERFACE IMPORTED)
+- add_library(Boost::dynamic_linking INTERFACE IMPORTED)
++if(NOT TARGET boost_diagnostic_definitions)
++ add_library(boost_diagnostic_definitions INTERFACE IMPORTED)
++ add_library(boost_disable_autolinking INTERFACE IMPORTED)
++ add_library(boost_dynamic_linking INTERFACE IMPORTED)
+ endif()
+ if(WIN32)
+ # In windows, automatic linking is performed, so you do not have
+@@ -1259,11 +1255,11 @@ if(WIN32)
+ # code to emit a #pragma message each time a library is selected
+ # for linking.
+ set(Boost_LIB_DIAGNOSTIC_DEFINITIONS "-DBOOST_LIB_DIAGNOSTIC")
+- set_target_properties(Boost::diagnostic_definitions PROPERTIES
++ set_target_properties(boost_diagnostic_definitions PROPERTIES
+ INTERFACE_COMPILE_DEFINITIONS "BOOST_LIB_DIAGNOSTIC")
+- set_target_properties(Boost::disable_autolinking PROPERTIES
++ set_target_properties(boost_disable_autolinking PROPERTIES
+ INTERFACE_COMPILE_DEFINITIONS "BOOST_ALL_NO_LIB")
+- set_target_properties(Boost::dynamic_linking PROPERTIES
++ set_target_properties(boost_dynamic_linking PROPERTIES
+ INTERFACE_COMPILE_DEFINITIONS "BOOST_ALL_DYN_LINK")
+ endif()
+
+@@ -1738,7 +1734,7 @@ if("thread" IN_LIST Boost_FIND_COMPONENTS)
+ else()
+ set(_Boost_find_quiet "")
+ endif()
+- find_package(Threads ${_Boost_find_quiet})
++ find_package(boost_thread ${_Boost_find_quiet})
+ unset(_Boost_find_quiet)
+ endif()
+
+@@ -2079,61 +2075,61 @@ endif()
+
+ if(Boost_FOUND)
+ # For header-only libraries
+- if(NOT TARGET Boost::boost)
+- add_library(Boost::boost INTERFACE IMPORTED)
++ if(NOT TARGET Boost_boost)
++ add_library(Boost_boost INTERFACE IMPORTED)
+ if(Boost_INCLUDE_DIRS)
+- set_target_properties(Boost::boost PROPERTIES
++ set_target_properties(Boost_boost PROPERTIES
+ INTERFACE_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIRS}")
+ endif()
+ endif()
+
+ foreach(COMPONENT ${Boost_FIND_COMPONENTS})
+- if(_Boost_IMPORTED_TARGETS AND NOT TARGET Boost::${COMPONENT})
++ if(_Boost_IMPORTED_TARGETS AND NOT TARGET Boost_${COMPONENT})
+ string(TOUPPER ${COMPONENT} UPPERCOMPONENT)
+ if(Boost_${UPPERCOMPONENT}_FOUND)
+ if(Boost_USE_STATIC_LIBS)
+- add_library(Boost::${COMPONENT} STATIC IMPORTED)
++ add_library(Boost_${COMPONENT} STATIC IMPORTED)
+ else()
+ # Even if Boost_USE_STATIC_LIBS is OFF, we might have static
+ # libraries as a result.
+- add_library(Boost::${COMPONENT} UNKNOWN IMPORTED)
++ add_library(Boost_${COMPONENT} UNKNOWN IMPORTED)
+ endif()
+ if(Boost_INCLUDE_DIRS)
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ INTERFACE_INCLUDE_DIRECTORIES "${Boost_INCLUDE_DIRS}")
+ endif()
+ if(EXISTS "${Boost_${UPPERCOMPONENT}_LIBRARY}")
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ IMPORTED_LINK_INTERFACE_LANGUAGES "CXX"
+ IMPORTED_LOCATION "${Boost_${UPPERCOMPONENT}_LIBRARY}")
+ endif()
+ if(EXISTS "${Boost_${UPPERCOMPONENT}_LIBRARY_RELEASE}")
+- set_property(TARGET Boost::${COMPONENT} APPEND PROPERTY
++ set_property(TARGET Boost_${COMPONENT} APPEND PROPERTY
+ IMPORTED_CONFIGURATIONS RELEASE)
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ IMPORTED_LINK_INTERFACE_LANGUAGES_RELEASE "CXX"
+ IMPORTED_LOCATION_RELEASE "${Boost_${UPPERCOMPONENT}_LIBRARY_RELEASE}")
+ endif()
+ if(EXISTS "${Boost_${UPPERCOMPONENT}_LIBRARY_DEBUG}")
+- set_property(TARGET Boost::${COMPONENT} APPEND PROPERTY
++ set_property(TARGET Boost_${COMPONENT} APPEND PROPERTY
+ IMPORTED_CONFIGURATIONS DEBUG)
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ IMPORTED_LINK_INTERFACE_LANGUAGES_DEBUG "CXX"
+ IMPORTED_LOCATION_DEBUG "${Boost_${UPPERCOMPONENT}_LIBRARY_DEBUG}")
+ endif()
+ if(_Boost_${UPPERCOMPONENT}_DEPENDENCIES)
+ unset(_Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES)
+ foreach(dep ${_Boost_${UPPERCOMPONENT}_DEPENDENCIES})
+- list(APPEND _Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES Boost::${dep})
++ list(APPEND _Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES Boost_${dep})
+ endforeach()
+ if(COMPONENT STREQUAL "thread")
+- list(APPEND _Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES Threads::Threads)
++ list(APPEND _Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES boost_thread)
+ endif()
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ INTERFACE_LINK_LIBRARIES "${_Boost_${UPPERCOMPONENT}_TARGET_DEPENDENCIES}")
+ endif()
+ if(_Boost_${UPPERCOMPONENT}_COMPILER_FEATURES)
+- set_target_properties(Boost::${COMPONENT} PROPERTIES
++ set_target_properties(Boost_${COMPONENT} PROPERTIES
+ CXX_STANDARD 17)
+ endif()
+ endif()
+diff --git a/cmake/modules/Finddpdk.cmake b/cmake/modules/Finddpdk.cmake
+index 964ae5dfb0..92bf07c14e 100644
+--- a/cmake/modules/Finddpdk.cmake
++++ b/cmake/modules/Finddpdk.cmake
+@@ -102,9 +102,9 @@ if(dpdk_FOUND)
+
+ if(NOT TARGET dpdk::dpdk)
+ add_library(dpdk::dpdk INTERFACE IMPORTED)
+- find_package(Threads QUIET)
++ find_package(boost_thread QUIET)
+ list(APPEND dpdk_LIBRARIES
+- Threads::Threads
++ boost_thread
+ dpdk::cflags)
+ set_target_properties(dpdk::dpdk PROPERTIES
+ INTERFACE_LINK_LIBRARIES "${dpdk_LIBRARIES}"
+diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
+index 28ec9835f8..31a1efa19f 100644
+--- a/src/CMakeLists.txt
++++ b/src/CMakeLists.txt
+@@ -356,12 +356,12 @@ set(ceph_common_objs
+ set(ceph_common_deps
+ json_spirit erasure_code arch crc32
+ ${LIB_RESOLV}
+- Boost::thread
+- Boost::system
+- Boost::random
+- Boost::program_options
+- Boost::date_time
+- Boost::iostreams
++ boost_thread
++ boost_system
++ boost_random
++ boost_program_options
++ boost_date_time
++ boost_iostreams
+ ${BLKID_LIBRARIES}
+ ${Backtrace_LIBRARIES}
+ ${BLKIN_LIBRARIES}
+@@ -522,7 +522,7 @@ if (WITH_CEPHFS)
+ ceph_mds.cc)
+ add_executable(ceph-mds ${ceph_mds_srcs})
+ target_link_libraries(ceph-mds mds ${CMAKE_DL_LIBS} global-static ceph-common
+- Boost::thread)
++ boost_thread)
+ install(TARGETS ceph-mds DESTINATION bin)
+ endif()
+
+diff --git a/src/crimson/CMakeLists.txt b/src/crimson/CMakeLists.txt
+index d7b58521d4..e1533af33f 100644
+--- a/src/crimson/CMakeLists.txt
++++ b/src/crimson/CMakeLists.txt
+@@ -106,8 +106,8 @@ target_link_libraries(crimson-common
+ PRIVATE
+ crc32
+ crimson::cflags
+- Boost::iostreams
+- Boost::random
++ boost_iostreams
++ boost_random
+ ${NSS_LIBRARIES} ${NSPR_LIBRARIES} OpenSSL::Crypto)
+
+ set(crimson_auth_srcs
+diff --git a/src/mgr/CMakeLists.txt b/src/mgr/CMakeLists.txt
+index 252fb3e5e3..213482da16 100644
+--- a/src/mgr/CMakeLists.txt
++++ b/src/mgr/CMakeLists.txt
+@@ -26,7 +26,7 @@ target_include_directories(ceph-mgr SYSTEM PRIVATE "${PYTHON_INCLUDE_DIRS}")
+ target_link_libraries(ceph-mgr
+ osdc client heap_profiler
+ global-static ceph-common
+- Boost::python${MGR_PYTHON_VERSION_MAJOR}${MGR_PYTHON_VERSION_MINOR}
++ boost_python${MGR_PYTHON_VERSION_MAJOR}${MGR_PYTHON_VERSION_MINOR}
+ ${MGR_PYTHON_LIBRARIES} ${CMAKE_DL_LIBS} ${GSSAPI_LIBRARIES})
+ set_target_properties(ceph-mgr PROPERTIES
+ POSITION_INDEPENDENT_CODE ${EXE_LINKER_USE_PIE})
+diff --git a/src/rbd_replay/CMakeLists.txt b/src/rbd_replay/CMakeLists.txt
+index e9d3804c5f..5c6eb58de1 100644
+--- a/src/rbd_replay/CMakeLists.txt
++++ b/src/rbd_replay/CMakeLists.txt
+@@ -36,7 +36,7 @@ if(HAVE_BABELTRACE)
+ global
+ babeltrace
+ babeltrace-ctf
+- Boost::date_time
++ boost_date_time
+ )
+ install(TARGETS rbd-replay-prep DESTINATION bin)
+ endif(HAVE_BABELTRACE)
+diff --git a/src/rgw/CMakeLists.txt b/src/rgw/CMakeLists.txt
+index 82f5181f5b..8a51f140fb 100644
+--- a/src/rgw/CMakeLists.txt
++++ b/src/rgw/CMakeLists.txt
+@@ -202,7 +202,7 @@ if(WITH_CURL_OPENSSL)
+ endif()
+
+ if(WITH_BOOST_CONTEXT)
+- target_link_libraries(rgw_a PRIVATE Boost::coroutine Boost::context)
++ target_link_libraries(rgw_a PRIVATE boost_coroutine boost_context)
+ endif()
+
+ set(rgw_libs rgw_a)
+@@ -353,7 +353,7 @@ if(WITH_RADOSGW_AMQP_ENDPOINT)
+ target_link_libraries(rgw_admin_user PRIVATE RabbitMQ::RabbitMQ)
+ endif()
+ if(WITH_BOOST_CONTEXT)
+- target_link_libraries(rgw_admin_user PRIVATE Boost::coroutine Boost::context)
++ target_link_libraries(rgw_admin_user PRIVATE boost_coroutine boost_context)
+ endif()
+
+ if(WITH_TESTS)
+diff --git a/src/test/CMakeLists.txt b/src/test/CMakeLists.txt
+index 5dcee1694d..60743be698 100644
+--- a/src/test/CMakeLists.txt
++++ b/src/test/CMakeLists.txt
+@@ -159,7 +159,7 @@ add_executable(ceph_omapbench
+ )
+ target_link_libraries(ceph_omapbench
+ librados
+- Boost::program_options
++ boost_program_options
+ global
+ ${BLKID_LIBRARIES}
+ ${CMAKE_DL_LIBS}
+diff --git a/src/test/common/CMakeLists.txt b/src/test/common/CMakeLists.txt
+index 71fb77cda9..aff8fb6565 100644
+--- a/src/test/common/CMakeLists.txt
++++ b/src/test/common/CMakeLists.txt
+@@ -315,8 +315,8 @@ add_ceph_unittest(unittest_hobject)
+
+ add_executable(unittest_async_completion test_async_completion.cc)
+ add_ceph_unittest(unittest_async_completion)
+-target_link_libraries(unittest_async_completion Boost::system)
++target_link_libraries(unittest_async_completion boost_system)
+
+ add_executable(unittest_async_shared_mutex test_async_shared_mutex.cc)
+ add_ceph_unittest(unittest_async_shared_mutex)
+-target_link_libraries(unittest_async_shared_mutex ceph-common Boost::system)
++target_link_libraries(unittest_async_shared_mutex ceph-common boost_system)
+diff --git a/src/test/erasure-code/CMakeLists.txt b/src/test/erasure-code/CMakeLists.txt
+index 721f6c3675..1cd9635c77 100644
+--- a/src/test/erasure-code/CMakeLists.txt
++++ b/src/test/erasure-code/CMakeLists.txt
+@@ -2,15 +2,15 @@
+ add_executable(ceph_erasure_code_benchmark
+ ${CMAKE_SOURCE_DIR}/src/erasure-code/ErasureCode.cc
+ ceph_erasure_code_benchmark.cc)
+-target_link_libraries(ceph_erasure_code_benchmark ceph-common Boost::program_options global ${CMAKE_DL_LIBS})
++target_link_libraries(ceph_erasure_code_benchmark ceph-common boost_program_options global ${CMAKE_DL_LIBS})
+ install(TARGETS ceph_erasure_code_benchmark
+ DESTINATION bin)
+
+ add_executable(ceph_erasure_code_non_regression ceph_erasure_code_non_regression.cc)
+-target_link_libraries(ceph_erasure_code_non_regression ceph-common Boost::program_options global ${CMAKE_DL_LIBS})
++target_link_libraries(ceph_erasure_code_non_regression ceph-common boost_program_options global ${CMAKE_DL_LIBS})
+
+ add_executable(ceph_erasure_code ceph_erasure_code.cc)
+-target_link_libraries(ceph_erasure_code ceph-common Boost::program_options global ${CMAKE_DL_LIBS})
++target_link_libraries(ceph_erasure_code ceph-common boost_program_options global ${CMAKE_DL_LIBS})
+ install(TARGETS ceph_erasure_code
+ DESTINATION bin)
+
+diff --git a/src/test/librados/CMakeLists.txt b/src/test/librados/CMakeLists.txt
+index 4fc53d2406..e6304394f8 100644
+--- a/src/test/librados/CMakeLists.txt
++++ b/src/test/librados/CMakeLists.txt
+@@ -62,7 +62,7 @@ add_executable(ceph_test_rados_api_asio asio.cc)
+ target_link_libraries(ceph_test_rados_api_asio global
+ librados ${UNITTEST_LIBS})
+ if(WITH_BOOST_CONTEXT)
+- target_link_libraries(ceph_test_rados_api_asio Boost::coroutine Boost::context)
++ target_link_libraries(ceph_test_rados_api_asio boost_coroutine boost_context)
+ endif()
+
+ add_executable(ceph_test_rados_api_list
+@@ -132,7 +132,7 @@ add_executable(ceph_test_rados_api_tier_pp
+ tier_cxx.cc
+ $<TARGET_OBJECTS:unit-main>)
+ target_link_libraries(ceph_test_rados_api_tier_pp
+- librados global ${UNITTEST_LIBS} Boost::system radostest-cxx)
++ librados global ${UNITTEST_LIBS} boost_system radostest-cxx)
+
+ add_executable(ceph_test_rados_api_snapshots
+ snapshots.cc)
+diff --git a/src/test/librbd/CMakeLists.txt b/src/test/librbd/CMakeLists.txt
+index 3c3e9db6c1..2c208c1a4f 100644
+--- a/src/test/librbd/CMakeLists.txt
++++ b/src/test/librbd/CMakeLists.txt
+@@ -27,7 +27,7 @@ target_link_libraries(rbd_test PRIVATE
+ radostest
+ radostest-cxx
+ librados
+- Boost::thread
++ boost_thread
+ GMock::GMock
+ GTest::GTest)
+
+diff --git a/src/test/rgw/CMakeLists.txt b/src/test/rgw/CMakeLists.txt
+index cde6348d57..e6ce738834 100644
+--- a/src/test/rgw/CMakeLists.txt
++++ b/src/test/rgw/CMakeLists.txt
+@@ -144,7 +144,7 @@ add_ceph_unittest(unittest_rgw_dmclock_scheduler)
+ target_link_libraries(unittest_rgw_dmclock_scheduler radosgw_a dmclock)
+ if(WITH_BOOST_CONTEXT)
+ target_compile_definitions(unittest_rgw_dmclock_scheduler PRIVATE BOOST_COROUTINES_NO_DEPRECATION_WARNING)
+- target_link_libraries(unittest_rgw_dmclock_scheduler Boost::coroutine Boost::context)
++ target_link_libraries(unittest_rgw_dmclock_scheduler boost_coroutine boost_context)
+ endif()
+
+ if(WITH_RADOSGW_AMQP_ENDPOINT)
+diff --git a/src/tools/CMakeLists.txt b/src/tools/CMakeLists.txt
+index d31f3d2408..6945018b11 100644
+--- a/src/tools/CMakeLists.txt
++++ b/src/tools/CMakeLists.txt
+@@ -35,20 +35,20 @@ install(PROGRAMS
+ endif(WITH_TESTS)
+
+ add_executable(ceph-osdomap-tool ceph_osdomap_tool.cc)
+-target_link_libraries(ceph-osdomap-tool os global Boost::program_options)
++target_link_libraries(ceph-osdomap-tool os global boost_program_options)
+ install(TARGETS ceph-osdomap-tool DESTINATION bin)
+
+ add_executable(ceph-monstore-tool
+ ceph_monstore_tool.cc
+ ../mgr/mgr_commands.cc)
+-target_link_libraries(ceph-monstore-tool os global Boost::program_options)
++target_link_libraries(ceph-monstore-tool os global boost_program_options)
+ install(TARGETS ceph-monstore-tool DESTINATION bin)
+
+ add_executable(ceph-objectstore-tool
+ ceph_objectstore_tool.cc
+ rebuild_mondb.cc
+ RadosDump.cc)
+-target_link_libraries(ceph-objectstore-tool osd os global Boost::program_options ${CMAKE_DL_LIBS})
++target_link_libraries(ceph-objectstore-tool osd os global boost_program_options ${CMAKE_DL_LIBS})
+ if(WITH_FUSE)
+ target_link_libraries(ceph-objectstore-tool ${FUSE_LIBRARIES})
+ endif(WITH_FUSE)
diff --git a/sys-cluster/ceph/files/ceph-14.2.5-no-virtualenvs.patch b/sys-cluster/ceph/files/ceph-14.2.5-no-virtualenvs.patch
new file mode 100644
index 000000000000..5b7cb41c87ad
--- /dev/null
+++ b/sys-cluster/ceph/files/ceph-14.2.5-no-virtualenvs.patch
@@ -0,0 +1,39 @@
+diff --git a/src/pybind/mgr/dashboard/CMakeLists.txt b/src/pybind/mgr/dashboard/CMakeLists.txt
+index b6c7861838..8ce95a93a5 100644
+--- a/src/pybind/mgr/dashboard/CMakeLists.txt
++++ b/src/pybind/mgr/dashboard/CMakeLists.txt
+@@ -2,7 +2,7 @@ set(MGR_DASHBOARD_VIRTUALENV ${CEPH_BUILD_VIRTUALENV}/mgr-dashboard-virtualenv)
+
+ add_custom_target(mgr-dashboard-test-venv
+ COMMAND
+- ${CMAKE_SOURCE_DIR}/src/tools/setup-virtualenv.sh --python=${MGR_PYTHON_EXECUTABLE} ${MGR_DASHBOARD_VIRTUALENV}
++ #${CMAKE_SOURCE_DIR}/src/tools/setup-virtualenv.sh --python=${MGR_PYTHON_EXECUTABLE} ${MGR_DASHBOARD_VIRTUALENV}
+ WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src/pybind/mgr/dashboard
+ COMMENT "dashboard tests virtualenv is being created")
+ add_dependencies(tests mgr-dashboard-test-venv)
+@@ -14,9 +14,9 @@ function(add_npm_command)
+ set(multi_kw COMMAND DEPENDS)
+ cmake_parse_arguments(NC "${options}" "${single_kw}" "${multi_kw}" ${ARGN})
+ string(REPLACE ";" " " command "${NC_COMMAND}")
+- if(NC_NODEENV)
+- string(REGEX REPLACE "^(.*(npm|npx) .*)$" ". ${mgr-dashboard-nodeenv-dir}/bin/activate && \\1 && deactivate" command ${command})
+- endif()
++ #if(NC_NODEENV)
++ # string(REGEX REPLACE "^(.*(npm|npx) .*)$" ". ${mgr-dashboard-nodeenv-dir}/bin/activate && \\1 && deactivate" command ${command})
++ #endif()
+ string(REPLACE " " ";" command "${command}")
+ add_custom_command(
+ OUTPUT "${NC_OUTPUT}"
+@@ -41,9 +41,9 @@ else()
+
+ add_custom_command(
+ OUTPUT "${mgr-dashboard-nodeenv-dir}/bin/npm"
+- COMMAND ${CMAKE_SOURCE_DIR}/src/tools/setup-virtualenv.sh --python=${MGR_PYTHON_EXECUTABLE} ${mgr-dashboard-nodeenv-dir}
+- COMMAND ${mgr-dashboard-nodeenv-dir}/bin/pip install nodeenv
+- COMMAND ${mgr-dashboard-nodeenv-dir}/bin/nodeenv -p --node=10.13.0
++ #COMMAND ${CMAKE_SOURCE_DIR}/src/tools/setup-virtualenv.sh --python=${MGR_PYTHON_EXECUTABLE} ${mgr-dashboard-nodeenv-dir}
++ #COMMAND ${mgr-dashboard-nodeenv-dir}/bin/pip install nodeenv
++ #COMMAND ${mgr-dashboard-nodeenv-dir}/bin/nodeenv -p --node=10.13.0
+ WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+ COMMENT "dashboard nodeenv is being installed"
+ )
diff --git a/sys-cluster/ceph/metadata.xml b/sys-cluster/ceph/metadata.xml
index bfbf70b7a303..d69494c3b6dc 100644
--- a/sys-cluster/ceph/metadata.xml
+++ b/sys-cluster/ceph/metadata.xml
@@ -20,6 +20,7 @@
<flag name="babeltrace">Add support for LTTng babeltrace</flag>
<flag name="cephfs">Build support for cephfs, a POSIX compatible filesystem built on top of ceph</flag>
<flag name="dpdk">Enable DPDK messaging</flag>
+ <flag name="spdk">Enable SPDK user-mode storage driver toolkit</flag>
<flag name="fuse">Build fuse client</flag>
<flag name="grafana">Install grafana dashboards</flag>
<flag name="lttng">Add support for LTTng</flag>